#include<iostream>
#include<thrust/device_vector.h>
#include<thrust/host_vector.h>
#include <thrust/copy.h>
#include<thrust/sequence.h>
#include<cuda.h>
#include<cuda_runtime_api.h>
#include<cuda_runtime.h>
#include<time.h>
#include<stdlib.h>

#define MAX_RECURSION 24
#define WARP_SIZE 32
/**
*=========================================================
* PROCEDIMENTOS UTILITÁRIOS
*=========================================================
**/
__global__ void vectorPrinter(int *, int, int);
__device__ void swapKernel(int *, int *);

__device__ void pivotMedianOf3Kernel(int [], long, long, long *);
__device__ void oddEvenSortKernel(int *, long, long);

__global__ void intercalateKernel(int *, int *, long, long, long);
__global__ void indexSearchKernel(int *, int, int, int *);
__global__ void pushElementsKernel(int *, int, int);

__global__ void rankCalculatorKernel(int *, int *, int *, int, int);
__global__ void rankSumCalculatorKernel(int *, int *, int);

__global__ void quickSortKernel(int *, long, long);
__global__ void mergeSortKernel(int *, int *, long, long);
__global__ void insertionSortKernel(int *, long, int *);
__global__ void mergeSortKernel(int *, int *, int *,  int *, int *, int, int);

void mergeSort(int *, int *, int *, int, int);

void thrustSort(thrust::device_vector<int>, float *);